'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ValidatorMixin = {
    propTypes: {
        invalid: _react2.default.PropTypes.array,
        invalidTip: _react2.default.PropTypes.oneOf(['helpBlock', 'toolTip'])
    },
    getInitialState: function getInitialState() {
        return {
            errorMessages: []
        };
    },
    onCheck: function onCheck() {
        var invalid = this.props.invalid;
        var value = this.state.value;

        var errorMessages = [];

        invalid.map(function (func, index) {
            errorMessages.push(func(value));
        });

        this.setState({
            errorMessages: errorMessages
        });
    }
};

exports.default = ValidatorMixin;